package betterwithmods.module.gameplay;

import betterwithmods.api.util.IWood;
import betterwithmods.common.BWMBlocks;
import betterwithmods.common.BWOreDictionary;
import betterwithmods.common.BWRegistry;
import betterwithmods.common.registry.block.recipe.BlockDropIngredient;
import betterwithmods.common.registry.block.recipe.BlockIngredient;
import betterwithmods.common.registry.block.recipe.SawRecipe;
import betterwithmods.module.Feature;
import betterwithmods.module.ModuleLoader;
import betterwithmods.module.hardcore.crafting.HCLumber;
import betterwithmods.util.InvUtils;
import com.google.common.collect.Lists;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.util.NonNullList;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.event.FMLPostInitializationEvent;

import java.util.Random;

/**
 * Created by primetoxinz on 5/16/17.
 */
public class SawRecipes extends Feature {
    public SawRecipes() {
        canDisable = false;
    }

    @Override
    public void init(FMLInitializationEvent event) {


        BWRegistry.WOOD_SAW.addSelfdropRecipe(new ItemStack(Blocks.field_150423_aK));
        BWRegistry.WOOD_SAW.addSelfdropRecipe(new ItemStack(Blocks.field_150395_bd));
        BWRegistry.WOOD_SAW.addSelfdropRecipe(new ItemStack(Blocks.field_150327_N));
        BWRegistry.WOOD_SAW.addSelfdropRecipe(new ItemStack(Blocks.field_150338_P));
        BWRegistry.WOOD_SAW.addSelfdropRecipe(new ItemStack(Blocks.field_150337_Q));
        BWRegistry.WOOD_SAW.addSelfdropRecipe(new ItemStack(BWMBlocks.ROPE));
        for (int i = 0; i < 9; i++)
            BWRegistry.WOOD_SAW.addSelfdropRecipe(new ItemStack(Blocks.field_150328_O, 1, i));
        BWRegistry.WOOD_SAW.addRecipe(new SawRecipe(new BlockIngredient(new ItemStack(Blocks.field_150440_ba)), NonNullList.func_191196_a()) {
            @Override
            public NonNullList<ItemStack> getOutputs() {
                Random random = new Random();
                return InvUtils.asNonnullList(new ItemStack(Items.field_151127_ba, 3 + random.nextInt(5)));
            }
        });
    }

    @Override
    public void postInit(FMLPostInitializationEvent event) {
        int count = ModuleLoader.isFeatureEnabled(HCLumber.class) ? 4 : 6;
        for (IWood wood : BWOreDictionary.woods) {
            BWRegistry.WOOD_SAW.addRecipe(new BlockDropIngredient(wood.getLog(1)), Lists.newArrayList(wood.getPlank(count), wood.getBark(1), wood.getSawdust(2)));
        }
    }


}
